/*
  RGB raw file viewer

  T. Nakagawa
  2011/04/17
*/


#include <stdio.h>


#define WIDTH 132
#define HEIGHT 162


int main(int argc, char **argv) {
  int i, j;
  unsigned char rgb[WIDTH * HEIGHT * 3];
  unsigned short bmp[WIDTH * HEIGHT];
  unsigned char *ptr;

  fread(rgb, sizeof(unsigned char), WIDTH * HEIGHT * 3, stdin);
  for (i = 0; i < HEIGHT; i++) {
    ptr = &rgb[(HEIGHT - 1 - i) * WIDTH * 3];
    for (j = 0; j < WIDTH; j++) {
      bmp[i * WIDTH + j] = ((((unsigned short)ptr[0] >> 3) << 11) | (((unsigned short)ptr[1] >> 2) << 5) | ((unsigned short)ptr[2] >> 3));
      ptr += 3;
    }
  }
  fwrite("\x0e\x01", sizeof(char), 2, stdout);
  fwrite(bmp, sizeof(unsigned short), WIDTH * HEIGHT, stdout);

  return 0;
}
